// Controlling a servo position using a potentiometer (variable resistor)
// by Michal Rinott <http://people.interaction-ivrea.it/m.rinott>

#include <Servo.h>

#define SERVO_01 2
#define SERVO_02 3
#define SERVO_03 4
#define SERVO_04 5
#define SERVO_05 6

#define RANGE 60

Servo servo_01;
Servo servo_02;
Servo servo_03;
Servo servo_04;
Servo servo_05;


int i;    // variable to read the value from the analog pin
byte readByte;
int servoPos_01;
int servoPos_02;
int servoPos_03;
int servoPos_04;
int servoPos_05;

int servoPos_01_new;
int servoPos_02_new;
int servoPos_03_new;
int servoPos_04_new;
int servoPos_05_new;

int ADC_01;
int ADC_02;
int ADC_03;
int ADC_04;
int ADC_05;


void establishContact(){
  while (Serial.available() <= 0) {
    Serial.print('X');   // send a capital X
    delay(300);
  }
}


void initArm(){
  servoPos_01 = 1750;
  servoPos_02 = 1700;
  servoPos_03 = 1000;
  servoPos_04 = 1800;
  servoPos_05 = 1600;
  
  servoPos_01_new = servoPos_01;
  servoPos_02_new = servoPos_01;
  servoPos_03_new = servoPos_01;
  servoPos_04_new = servoPos_01;
  servoPos_05_new = servoPos_01;

  servo_01.writeMicroseconds(servoPos_01);
  servo_02.writeMicroseconds(servoPos_02);
  servo_03.writeMicroseconds(servoPos_03);
  servo_04.writeMicroseconds(servoPos_04);
  servo_05.writeMicroseconds(servoPos_05);
}

void setup(){

  servo_01.attach(SERVO_01, 500, 2500);
  servo_02.attach(SERVO_02, 500, 2500);
  servo_03.attach(SERVO_03, 500, 2500);
  servo_04.attach(SERVO_04, 500, 2500);
  servo_05.attach(SERVO_05, 500, 2500);

  initArm();

  pinMode(A5, INPUT);
  digitalWrite(A5, HIGH);

  // start serial port at 115200 bps:
  Serial.begin(115200);
//  establishContact();  // send a byte to establish contact until receiver responds


}

void loop(){

//  ADC_00 = analogRead(A0);
//  Serial.print(ADC_00);
//  Serial.print("  ");

  
  ADC_01 = analogRead(A1);
  Serial.print(ADC_01);
  Serial.print("  ");
  servoPos_01_new = map(ADC_01, 0, 1023, 2500, 500) + 250;
  if(servoPos_01_new > servoPos_01 + RANGE){
    servoPos_01++;
  }
  if(servoPos_01_new < servoPos_01 - RANGE){
    servoPos_01--;
  }
  servo_01.writeMicroseconds(servoPos_01);
  Serial.print(" P1=");
  Serial.print(servoPos_01);
  Serial.print(" ");
  delay(1);

  ADC_02 = analogRead(A2);
  Serial.print(ADC_02);
  Serial.print("  ");
  servoPos_02_new = map(ADC_02, 0, 1023, 500, 2500);
  if(servoPos_02_new > servoPos_02 + RANGE){
    servoPos_02++;
  }
  if(servoPos_02_new < servoPos_02 - RANGE){
    servoPos_02--;
  }
  servo_02.writeMicroseconds(servoPos_02);
  Serial.print(" P2=");
  Serial.print(servoPos_02);
  Serial.print(" ");
  delay(1);

  ADC_03 = analogRead(A3);
  Serial.print(ADC_03);
  Serial.print("  ");
  servoPos_03_new = map(ADC_03, 0, 1023, 2500, 500) - 400;
  if(servoPos_03_new > servoPos_03 + RANGE){
    servoPos_03++;
  }
  if(servoPos_03_new < servoPos_03 - RANGE){
    servoPos_03--;
  }
  servo_03.writeMicroseconds(servoPos_03);
  Serial.print(" P3=");
  Serial.print(servoPos_03);
  Serial.print(" ");
  delay(1);

  ADC_04 = analogRead(A4);
  Serial.print(ADC_04);
  Serial.print("  ");
  servoPos_04_new = map(ADC_04, 0, 1023, 2500, 500) + 250;
  if(servoPos_04_new > servoPos_04 + RANGE){
    servoPos_04++;
  }
  if(servoPos_04_new < servoPos_04 - RANGE){
    servoPos_04--;
  }
  servo_04.writeMicroseconds(servoPos_04);
  Serial.print(" P4=");
  Serial.print(servoPos_04);
  Serial.print(" ");
  delay(1);

  ADC_05 = digitalRead(A5);
  Serial.print(ADC_05);
  Serial.print("  ");
  if(ADC_05 == 0){
    servo_05.writeMicroseconds(1500);
  }
  else{
    servo_05.writeMicroseconds(1800);
  }
  Serial.print(" P5=");
  Serial.print(ADC_05);
  Serial.println(" ");
  delay(1);




  readByte = 0;
  if (Serial.available() > 0){//if we get a valid byte, read from serial:
    //get incoming byte:
    readByte = Serial.read();
    Serial.print('r');   // send a 'r' to initiate next data from computer
  }//if (Serial.available() > 0){

  if(readByte > 0){
    if(readByte == 'a'){
      if(servoPos_01 < 2500){
        servoPos_01++;
        servo_01.writeMicroseconds(servoPos_01);
      }
    }
    if(readByte == 'b'){
      if(servoPos_01 > 500){
        servoPos_01--;
        servo_01.writeMicroseconds(servoPos_01);
      }
    }

    if(readByte == 'c'){
      if(servoPos_02 < 2500){
        servoPos_02++;
        servo_02.writeMicroseconds(servoPos_02);
      }
    }
    if(readByte == 'd'){
      if(servoPos_02 > 500){
        servoPos_02--;
        servo_02.writeMicroseconds(servoPos_02);
      }
    }


    if(readByte == 'e'){
      if(servoPos_03 < 2500){
        servoPos_03++;
        servo_03.writeMicroseconds(servoPos_03);
      }
    }
    if(readByte == 'f'){
      if(servoPos_03 > 500){
        servoPos_03--;
        servo_03.writeMicroseconds(servoPos_03);
      }
    }

    if(readByte == 'g'){
      if(servoPos_04 < 2500){
        servoPos_04++;
        servo_04.writeMicroseconds(servoPos_04);
      }
    }
    if(readByte == 'h'){
      if(servoPos_04 > 500){
        servoPos_04--;
        servo_04.writeMicroseconds(servoPos_04);
      }
    }

    if(readByte == 'i'){
      if(servoPos_05 < 2500){
        servoPos_05++;
        servo_05.writeMicroseconds(servoPos_05);
      }
    }
    if(readByte == 'j'){
      if(servoPos_05 > 500){
        servoPos_05--;
        servo_05.writeMicroseconds(servoPos_05);
      }
    }

    if(readByte == 'Z'){
      initArm();
    }


  }



//  delay(100);
}
